#*    dsgui - a graphical user interface for Datove schranky
#*    Copyright (C) 2009-2010  CZ.NIC, z.s.p.o. (http://www.nic.cz)
#*
#*    This library is free software; you can redistribute it and/or
#*    modify it under the terms of the GNU Library General Public
#*    License as published by the Free Software Foundation; either
#*    version 2 of the License, or (at your option) any later version.
#*
#*    This library is distributed in the hope that it will be useful,
#*    but WITHOUT ANY WARRANTY; without even the implied warranty of
#*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#*    Library General Public License for more details.
#*
#*    You should have received a copy of the GNU Library General Public
#*    License along with this library; if not, write to the Free
#*    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

import urllib2
import re

VERSION_URL = "http://labs.nic.cz/page/708/verze-dsgui/"

def _strip_html_tags(text):
  text = " ".join(text.split())
  text = text.replace(" <p>","").replace("<p>","").replace("</p>","\n\n")
  return text

def check_version(current):
  """
  based on current version returns the name of the newest version or None
  if there is no newer version available.
  As a second return value returns the description of the release
  """
  try:
    d = urllib2.urlopen(VERSION_URL, timeout=5)
  except:
    return None, None
  else:
    data = d.read()
    d.close()
    versions = re.findall("<h2>verze (.*?)</h2>\s*((?:<p>.*?</p>\s*)+)",
                          data, re.DOTALL)
    numbers = [v[0] for v in versions]
    if current in numbers:
      # current is an official release, we continue
      if numbers.index(current) > 0:
        return versions[0][0], _strip_html_tags(versions[0][1])
  return None, None
